/* ========================================================================= *
 * Sort
 * ========================================================================= */

#ifndef _SORT_H_
# define _SORT_H_

#include <stddef.h>


/* ------------------------------------------------------------------------- *
 * Sort an array of integers with the insertion sort algorithm
 *
 * PARAMETERS
 * array        The array to sort
 * length       Number of elements in the array
 * ------------------------------------------------------------------------- */
void insertionSort(int* array, size_t length);

/* ------------------------------------------------------------------------- *
 * Sort an array of integers with the standard QuickSort algorithm
 *
 * PARAMETERS
 * array        The array to sort
 * length       Number of elements in the array
 * ------------------------------------------------------------------------- */
void quickSort(int* array, size_t length);

/* ------------------------------------------------------------------------- *
 * Sort an array of integers with the random-pivot QuickSort algorithm 
 *
 * PARAMETERS
 * array        The array to sort
 * length       Number of elements in the array
 * ------------------------------------------------------------------------- */
void randomizedQuickSort(int* array, size_t length);

/* ------------------------------------------------------------------------- *
 * Sort an array of integers with the HeapSort algorithm
 *
 * PARAMETERS
 * array        The array to sort
 * length       Number of elements in the array
 * ------------------------------------------------------------------------- */
void heapSort(int* array, size_t length);

/* ------------------------------------------------------------------------- *
 * Sort an array of integers with the HybridSort algorithm
 *
 * PARAMETERS
 * array        The array to sort
 * length       Number of elements in the array
 * k            The recursion threshold multiplier
 * ------------------------------------------------------------------------- */
void hybridSort(int* array, size_t length, double k);


#endif // !_SORT_H_
